#include <stdio.h>
#include <stdlib.h>  /* for atof() */

#include "getop.h"
#include "stack.h"
/* Note that getch.h is *not* included, because the main module
   does not use it, directly. */

#define MAXOP 100    /* max size of operand or operator */

/* reverse Polish calculator */
int main()
{
  int type;
  double op2;
  char s[MAXOP];
  
  while ((type = getop(s)) != EOF)
    switch (type) {
      
      case NUMBER:
	push(atof(s));
	break;
	
      case '+':
	push(pop() + pop());
	break;
	
      case '-':
	/* Note that we should *not* do 
	        push(pop() - pop()) 
	   here.  Why not? */
	op2 = pop();
	push(pop() - op2);
	break;
	
      case '*':
	push (pop() * pop());
	break;
	
      case '/':
	op2 = pop();
	if (op2 != 0.0) {
	  push (pop() / op2);
	} else {
	  printf ("Division by zero.\n");
	  exit (-1);
	}
	break;
	
      case '\n':
	printf("\t%.8lf\n", pop());
	break;
	
      default:
	printf("error: unknown command %s\n", s);
	exit(-1);
	break;
      }
  return 0;
}
